#=========================
#ReadRules: v2.0
#Last update: 17th March 2010
#Script Created by "AnOmaly"
#=========================
# Thanks to Xe_Manup for extensive help on cfglib
# Thanks to GodJonez/ojii for bits of help on IRC
# Thanks to clan members Vortex and Nooby for helping me translate the rules.
# And thanks to Health#oG for allowing me to test on his server.

import es, playerlib, popuplib, cfglib, langlib, gamethread, usermsg, services, random

__version__ = '2.0'
es.ServerVar('readrules_version', __version__).makepublic()

info = es.AddonInfo()
info.name          = "ReadRules"
info.version       = "2.0"
info.author        = "Anomaly"
info.url           = "http://addons.eventscripts.com/addons/view/es_readrules"
info.basename      = "readrules"
info.description   = "This script prevents players from being able to play properly on your server until they accept your servers rules." 

#Import settings.cfg for script settings.
config = cfglib.AddonCFG(es.getAddonPath('readrules') + '/settings.cfg')
config.text('Main Settings:')
config.text('---------------------------')
config_punish_method             = config.cvar('config_punish_method', '2', 'Set to 1 if you would like players who havent accepted the rules to be sent to spectate when they try to pick a team, set to 2 to allow them to spawn but be frozen + other punishments (or none of these and therefore they just have a popup which wont go until accepted).')
config.text(' ')
config_punish_method_overlay     = config.cvar('config_punish_method_overlay', '1', 'Set to 1 if you would like the player to be sent an overlay (contains arrow pointing at the rules). Set to 0 to disable.')
config_punish_method_timer       = config.cvar('config_punish_method_timer', '30', 'If you would like a time limit players must agree to the rules within, set to x seconds. Default = 30 seconds. If not set to 0 to disable.')
config.text(' ')
config.text('If config_punish_method is set to 1 the following options are available:')
config_punish_method_1_autojoin  = config.cvar('config_punish_method_1_autojoin', '1', '---Set to 1 if you would like the player to autojoin a team once the rules have been accepted. Set to 0 to disable.')
config.text(' ')
config.text('If config_punish_method is set to 2 the following options are available:')
config_punish_method_2_freeze    = config.cvar('config_punish_method_2_freeze', '1', '---Set to 1 if you would like the player to be frozen in place when they spawn. Set to 0 to disable.')
config_punish_method_2_invisible = config.cvar('config_punish_method_2_invisible', '1', '---Set to 1 if you would like the player to be made invisible while frozen. Set to 0 to disable.')
config_punish_method_2_god       = config.cvar('config_punish_method_2_god', '1', '---Set to 1 if you would like the player to be made invisible while frozen. Set to 0 to disable.')
config_punish_method_2_strip     = config.cvar('config_punish_method_2_strip', '1', '---Set to 1 if you would like to strip player of all weapons. Set to 0 to disable.')
config.text(' ')
config_immunity_basicauth        = config.cvar('config_immunity_basicauth', '1', 'Set to 1 if you want to enable basic_auth admins immunity, basic_auth admins are set in the autoexec.cfg. Set to 0 to disable.')
config_immunity_additional       = config.cvar('config_immunity_additional', 'STEAM_0:0:109012;STEAM_0:1:16606980', 'If you want certain steam ids not have to agree to the rules add in the following list. Leave empty if not.')
config.text(' ')
config_optional_popup            = config.cvar('config_optional_popup', '!rules', 'If you want the optional popup so player can view the rules once in game set this to a command of your liking, if not set to 0.')
config_popup_add_empty_lines     = config.cvar('config_popup_add_empty_lines', '1', 'Set to 1 if you want the popup to have empty lines seperating key parts, i recommend to leave this at 1. Set to 0 to disable.')

#This line needed to create/run the cfg file.
config.write()

#Import rules.ini for language translation.
translate = langlib.Strings(es.getAddonPath('readrules') + '/rules.ini')
#Import rules.ini for adding rules to popup.
ini = cfglib.AddonINI(es.getAddonPath('readrules') + '/rules.ini')        

#Creation of Dictionaries/Lists used throughout the script.
#Lists
accepting = [] #stores userid's in process of accepting the rules.
accepted = [] #stores userid's who have accepted the rules.
non_auth_steamids_list = [] #stores steamids who are immune to having to agree to rules.
#Dictionaries
popupdict = {} #stores the pagepopupnumber for use in detailed rules.

def load():
  #This line needed to create/run the cfg file.   
  config.execute()
  
  #Add string of additional immunity steam ids into list format
  to_be_split = str(config_immunity_additional) #creates a string so we can split the servervar brought from settings.cfg
  non_auth_steamids_list = to_be_split.split(';')
  
  #The 'readrules' overlay
  global overlaylist, overlaydir
  overlaylist = ['readrules.vmt','readrules.vtf']
  overlaydir = 'readrules/'
  es.flags('remove', 'cheat', 'r_screenoverlay') #Makes r_screenoverlay not require cheats.
               
  from configobj import ConfigObj
  global inidict
  inidict = ConfigObj(ini)  

  pagepopupnumber = 1
  rulenumber = 1 #rule number within the ini file, this goes past 8.
  #Adding extra popup if needed.
  while pagepopupnumber != 0:
    pagepopupnumber2 = pagepopupnumber
    #create main agree/disagree popup.
    rr_popup = popuplib.create('rr_page'+str(pagepopupnumber))  
    #create popup for !rules in chat.
    rr_popuprules = popuplib.create('rules'+str(pagepopupnumber)) 
    
    #create dicts containing popup numbers for detailed rules use.
    popupdict['rr_page'+str(pagepopupnumber)] = pagepopupnumber
    popupdict['rules'+str(pagepopupnumber)] = pagepopupnumber
    
    #Adding lines to optional popup.
    ruleslinenumber = 1
    rulesline = 1
    while rulesline != 0:
      rulesline = 'rules_line'+str(ruleslinenumber)
      if rulesline in inidict:
        ruleslinevalue = inidict[rulesline]
        for langrulesline in ruleslinevalue:
          rr_popuprules.addline(str(inidict[rulesline][langrulesline]), str(langrulesline))
        ruleslinenumber += 1
      else:
        rulesline = 0 
    
    #Adding lines to main popup.
    linenumber = 1
    line = 1
    while line != 0:
      line = 'line'+str(linenumber)
      if line in inidict:
        linevalue = inidict[line]
        for langline in linevalue:
          rr_popup.addline(str(inidict[line][langline]), str(langline))
        linenumber += 1
      else:
        line = 0  
    
    #Add empty line if setting enabled.
    if config_popup_add_empty_lines:
      rr_popup.addlineAll(' ')
      rr_popuprules.addlineAll(' ')   
        
    #Adding rules to popup.
    rulepopupnumber = 1 #rule popup number for popup, this can only go up to 8.
    rule = 1 #the section name from the ini file e.g. "rule1".
    while rule != 0:     
      rule = 'rule'+str(rulenumber)
      if rule in inidict:
        if rulepopupnumber == 8:
          rulepopupnumber = 1
          pagepopupnumber += 1
          break 
        else:
          rulevalue = inidict[rule]
          for langrule in rulevalue:
            rr_popup.addline('->'+str(rulepopupnumber)+'. '+str(inidict[rule][langrule]), str(langrule))
            rr_popup.select(rulepopupnumber,detailed_rules)
            rr_popuprules.addline('->'+str(rulepopupnumber)+'. '+str(inidict[rule][langrule]), str(langrule))
            rr_popuprules.select(rulepopupnumber,detailed_rules)       
          rulenumber += 1
          rulepopupnumber += 1
      else:
        rule = 0
        pagepopupnumber = 0
        #Because sticky popup isnt working, if theyre are blank rules (e.g. 5 rules) selecting the 6th wont close the menu.
        while rulepopupnumber < 8:
          rr_popup.select(rulepopupnumber,detailed_rules)
          rr_popuprules.select(rulepopupnumber,detailed_rules)
          rulepopupnumber += 1  
    
    #Add empty line if setting enabled.
    if config_popup_add_empty_lines:
      rr_popup.addlineAll(' ')
      rr_popuprules.addlineAll(' ')                                                                                                                  
    
    #Add Back line if needed.
    if pagepopupnumber2 > 1:
      backvalue = inidict['back']
      for langback in backvalue:
        backnext_pagenumber = pagepopupnumber2 - 1
        rr_popup.addline('8. '+str(inidict['back'][langback]), str(langback))
        rr_popup.submenu(8, 'rr_page'+str(backnext_pagenumber))
        rr_popuprules.addline('8. '+str(inidict['back'][langback]), str(langback))
        rr_popuprules.submenu(8, 'rules'+str(backnext_pagenumber))  
    else:
      #If not needed dont allow it to close either popups.
      rr_popup.select(8,detailed_rules)
      rr_popuprules.select(8,detailed_rules)
    
    #Add Next line if needed.
    if pagepopupnumber != 0:
      nextvalue = inidict['next']
      for langnext in nextvalue:
        backnext_pagenumber = pagepopupnumber2 + 1
        rr_popup.addline('9. '+str(inidict['next'][langnext]), str(langnext))
        rr_popup.submenu(9, 'rr_page'+str(backnext_pagenumber))
        rr_popuprules.addline('9. '+str(inidict['next'][langnext]), str(langnext))
        rr_popuprules.submenu(9, 'rules'+str(backnext_pagenumber))
    else:
       #If not needed dont allow it to close the !rules popup.
       rr_popuprules.select(9,detailed_rules)

    #Add Decline line.
    if pagepopupnumber == 0:
      declinevalue = inidict['decline']
      for langdecline in declinevalue:
        rr_popup.addline('9. '+str(inidict['decline'][langdecline]), str(langdecline))
        rr_popup.select(9,decline)
    
    #Add Accept line.
    if pagepopupnumber == 0:
      acceptvalue = inidict['accept']
      for langaccept in acceptvalue:
        rr_popup.addline('0. '+str(inidict['accept'][langaccept]), str(langaccept))
        rr_popup.select(10,accept)
    else:
       #If not needed dont allow it to close the agree/disagree popup.
       rr_popup.select(10,detailed_rules)
        
    #Add Close line for the !rules popup.
    closevalue = inidict['close']
    for langclose in closevalue:
      rr_popuprules.addline('0. '+str(inidict['close'][langclose]), str(langclose))
      rr_popuprules.select(10, close)
      
    #Add Basic Auth
    global isAuthed
    if services.isRegistered('auth'):
      auth_service = services.use('auth')
      auth_service.registerCapability('readrules', auth_service.ADMIN)
      isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'readrules')
    else:
      isAuthed = lambda x: False
  es.msg("#multi", "#green[ReadRules]:#lightgreen v"+__version__+"#default has been Loaded. Script created by AnOmaly")
   
def unload():
  pagepopupnumber = 1
  rr_page = 'rr_page'+str(pagepopupnumber)
  rules = 'rules'+str(pagepopupnumber)
  if popuplib.exists(rr_page):
    popuplib.delete(rr_page)
    popuplib.delete(rules)
  
  es.msg("#multi", "#green[ReadRules]:#lightgreen v"+__version__+"#default has been Un-Loaded. Script created by AnOmaly")

#Making overlay downloadable.
def adddownloads():
  for overlaytitle in overlaylist:
      es.stringtable('downloadables', 'materials/overlays/' + overlaydir + overlaytitle)

#If Overlay option turned on, add the downloadable content.        
def es_map_start(event_var):
  if config_punish_method_overlay: 
    adddownloads()
  #If player joins, and is in accepting state, then map changes, he cant accept, so restart the process.
  for player in accepting:
    accepting.remove(player)
    

#timer function
def timer(userid, time):
  if es.exists('userid', userid):
    if userid not in accepted: 
      #Use playerlib to get language.
      player = playerlib.getPlayer(userid)
      if time == 0:
        kickmessage = translate('decline_kick_message', 'miss me', player.get('lang'))
        player.kick(kickmessage)
      else:    
        #Send bottom hud in users language.
        timermessage = translate('timer', 'miss me', player.get('lang'))  
        usermsg.hudhint(userid, timermessage % time) 
        #Subtract 1 from time.
        time -= 1
        #Redo this function in 1 second with same args.
        gamethread.delayed(1, timer, args=(userid, time))
        if config_punish_method_overlay:
          es.cexec(userid, 'r_screenoverlay overlays/readrules/readrules')

#Used to strip player.      
def item_pickup(event_var):
  if config_punish_method == 2:
    if config_punish_method_2_strip:
      userid = event_var['userid']
      if userid not in accepted:
        weapon = event_var['item']
        es.sexec(userid, 'use '+weapon)         
        es.sexec(userid, 'drop')
  
def decline(userid, choice, popup):
  player = playerlib.getPlayer(userid)
  kickmessage = translate('decline_kick_message', 'miss me', player.get('lang'))
  player.kick(kickmessage)
  
def accept(userid, choice, popup):
  player = playerlib.getPlayer(userid)
  userid = str(userid)
  
  accepted.append(userid)
  accepting.remove(userid) 
      
  welcomemessage = translate('accept_message', 'miss me', player.get('lang'))
  es.tell(userid, "#multi", "#green[ReadRules]: #default"+welcomemessage)  
  
  #Remove Overlay
  if config_punish_method_overlay:
    es.cexec(userid, 'r_screenoverlay overlays/readrules/readrules0')
  
  if config_punish_method == 1:
    if config_punish_method_1_autojoin:
      #Autojoin team
      team = random.randint(2,3) 
      es.changeteam(userid,team)  
      
  if player.team == 2 or 3:
    if config_punish_method == 2:
      #UN-freeze
      if config_punish_method_2_freeze:
        player.freeze(0)
      #make visible
      if config_punish_method_2_invisible:  
        player.setColor(255, 255, 255, 255)
      #UN-godmode
      if config_punish_method_2_god:
        player.godmode(0)
      #Stripped weapons can be bought/picked up.

def detailed_rules(userid, choice, popup):
  player = playerlib.getPlayer(userid)
  
  #subtract 1 from the popup number.
  pagepopupnumber = popupdict[popup]
  pagepopupnumber = int(pagepopupnumber)
  pagepopupnumber -= 1
  
  #Work out from popup number and choice the detailed rule to send.
  if (pagepopupnumber != 0):
    rulenumber = (pagepopupnumber*7) + choice
  else:                             
    rulenumber = choice
  
  detail = 'rule'+str(rulenumber)+'_detail' 
  if detail in inidict:
    detailvalue = translate('rule'+str(rulenumber)+'_detail', 'miss me', player.get('lang'))
    es.tell(userid, "#multi", "#green[ReadRules]: #default"+detailvalue)  

  popuplib.send(popup, userid)


def close(userid, choice, popup):
  #Close popup if 0 is selected on !rules popup
  popuplib.close(popup, userid)  

def player_spawn(event_var):
  userid = event_var['userid']
  steamid = event_var['es_steamid'] 
  player = playerlib.getPlayer(event_var['userid'])
  
  #Checks to see if player has accepted
  if userid not in accepted: 
    #If not accepted
    #Checks if Bot
    if es.isbot(userid):
      accepted.append(userid) 
    #Checks if baisc_auth admin setting enabled
    elif config_immunity_basicauth: 
      if isAuthed(userid):
        accepted.append(userid)
    #Checks if readrules admin
    elif steamid in non_auth_steamids_list:
      accepted.append(userid)
      
    #If non of the above do following
    if userid not in accepted:
      #Wont be run again if popup has already been sent. The following is sent when a player joins the server (pretty much..)
      if userid not in accepting:
        #Tell script he is in process of accepting
        accepting.append(userid)
        #Send popup
        popuplib.send('rr_page1', userid)
        
        #Overlay
        if config_punish_method_overlay:
          es.cexec(userid, 'r_screenoverlay overlays/readrules/readrules')
        #Timer
        if config_punish_method_timer:
          timer(userid,int(config_punish_method_timer))
                                                                                          
      if player.team == 2 or 3:
        if config_punish_method == 1:
          es.changeteam(userid,1) 
        
        if config_punish_method == 2:
          #freeze
          if config_punish_method_2_freeze:
            player.freeze(1)
          #invisible
          if config_punish_method_2_invisible:  
            player.setColor(255, 255, 255, 0)
          #godmode
          if config_punish_method_2_god:
            player.godmode(1)
          #strip - done via item pickup.    
  
def player_say(event_var):
  if config_optional_popup != '0':
    if event_var['text'] == config_optional_popup:
      popuplib.send('rules1', event_var['userid'])
  
def player_disconnect(event_var):
  userid = event_var['userid']
  if userid in accepting:
    accepting.remove(userid) 
  if userid in accepted:
    accepted.remove(userid)

